; ***********************************************
; * R-dimmer/switch 3.0							*
; * - 18.8.04:heleduse juhtimine mber tehtud  	*
; * - vile det. paremaks                		*
; ***********************************************   
; parameetrid konfitavaks ja EEPROMi 
; sujuv sisse/vlja llit/konfitav
; IR-klahvide ppimine?
; vilguta aadressi muutmise peale -see ei funksi 
; vilistades vilgub sest T1 katkestus magatakse maha. Kontroll WhiCnt1 letitumise jrgi? Keelaks siis mici katkestuse kuni vrgukatk-ni?
; ei aita, kontrollix hoopis T1 lpule lhenemist - ikka ei aita :( Vahetasin Mic-i otsa: GP3-lt GP1-le. Parem, resetti ei tee. Aga probleem jb.
	INCLUDE "P12F629.inc" 
 	__CONFIG _INTRC_OSC_NOCLKOUT & _PWRTE_ON & _BODEN_OFF & _MCLRE_OFF & _WDT_OFF & _CP_OFF & _CPD_OFF   
	errorlevel	-302							; kompailer ei aja lolli ila ;)
	
; ***** Variables Definitions *****    
RAMbase         equ     20h            
	cblock  	RAMbase                 
				flags1  ;20               
				flags                 
				temp                 
				Table_Temp                 
				W_Temp                 
				S_Temp                 
				T_Temp                 
				Old_T_Temp                 
				RC5_Bit_Count                 
				RC5_Command                 
				RC5_Address;2a
				CmdCounter
				Debounce
				;Debounce1
				Last_Cmd
				Last_Adr         
				DIM_Value;30
				DIM_Temp
				Dim_Tick
				Device_Address_S				; here's R-switches current address
				Device_Address_D				; here's R-dimmers current address
				temp_2 ;35 
				WhiCnt1							; counts whistle pulses during one power-line period
				WhiCnt2
				SciCnt
				Last_GPIO						; state of I/O-port
	tmp
	bitcount
	count
		endc 
				org H'2100' 					; Initialize EEPROM Data
				de 11h							; default address for R-switch, device nr.1
				de 01h							; default address for R-dimmer, device nr.1
; R-dimmer address, range: 0001... 1111 i.e. up to 15 devices
; R-switch address, range: 0001... 1111 i.e. up to 15 devices
; bit 4 in address defines switch or dimmer:
;        ADR,4=0 -> command to R-Dimmer    
;        ADR,4=1 -> command to R-Switch
    
; ***** Definitions ***** 
; ***** constants *******
#define MinDim		0x01						; minimum brightness value (00h i.e switched off)
#define MaxDim		.27							; maximum brightness value (1Fh i.e switched on)
#define DimTickDefL	0xC7						; dimtimer reload value 
#define DimTickDefH	0xFE						
#define MinTime		.10							; nr. of sound periods: (low freq. limit)
#define MaxTime		.40							; nr. of sound periods: (high freq. limit)
#define WhiLen		0x10						; required length of whistle (nr. of mains half-periods)
#define	SciTime		.100
; ***** Hardware ******** 
#define Dimmer			GPIO,5					; Dimmer's triac steering output
#define Button	      	GPIO,0	                ; Control button
#define	Mic				GPIO,3					; Mic input
#define	Line_in			GPIO,4					; Input for syncing to mains voltage 
#define	Switch			GPIO,1					; Switch's triac steering output
#define	RS232_TX			GPIO,1					; test rs232 vljund
#define	RxD				GPIO,2					; Radio- & IR signals input
; ***** various flags ***
#define	LastDirection	flags,0					; 1 if we increased brightness, 0 if decreased (button press)
#define Last_RC5_Bit    flags,1                 ; Last RC5 bit received 
#define RC5_2nd_Bit     flags,2                 ; Add 2 RC5 bits 
#define RC5_2nd_Value   flags,3                 ; 2nd RC5 bit received 
#define RC5_Bit         flags,4                 ; 1st RC5 bit received 
#define New_adr_coming	flags,5					; next received command will be interpreted as an address if this flag is set
#define Line_Flag		flags,6					; 1 if it was positive 1/2 period
#define Key_down		flags,7					; 1 if button pressed
#define	LastVoice		flags1,0				; 1 if going to switch lights on in response to whistle
#define	WhiDet			flags1,1				; 1 if qualified whistle sounded somewhere nearby
#define CheckTime		flags1,2				; time to check keys after each power line zero crossing
#define	Silencio		flags1,3				; 1 for SciTime after every sound event has processed
#define CARRY           STATUS,C 
#define ZERO            STATUS,Z 
#define	pank			STATUS,RP0
#define R_Addr_S        d'0'					; Data-Eeprom location containing R-switches default address
#define R_Addr_D        d'1'					; Data-Eeprom location containing R-dimmers default address

;device aadresses
#define CIRCULAR		b'00000000'				; address 00h means that command will be sent to ALL active devices
#define Dev_Adr_Def_S	b'00010001'				; Default address for R-switch,restored by pressing Button at start-up (in case of lost program)
#define Dev_Adr_Def_D	b'00000001'				; same for R-dimmer

;commands
#define NEW_ADDR		b'00000000'				; receive new aadress (4 bits in command section of next TESTTIMES packets, 5-th bit=0)
#define COMON			b'00000001'				; switch on R-switch
#define COMOFF			b'00000010'				; switch off R-switch
#define DIMPLUS			b'00000001'				; increase brightness of R-dimmers load
#define DIMMINUS		b'00000010'				; decrease brightness of R-dimmers load
#define DIMVALUE		b'00000011'				; set dimmers loads brightness; bits 6,5,4,3,2 carry brightness value (32 valid values)
#define TESTTIMES		d'3'					; receive command as much times and compare, if all same - do it!

; ***** RESET *****          
				org     0000h 
Reset         
				goto    Main_Start       		; Skip interrupt routines, start program  
; ***** INTERRUPT *****  
; *************************************************************
; * NB! This interrupt routine is written by Edward Cardew    * 
; * (Edward_Cardew@aia.com ) originally for PIC16C84          *
; * Authors remark:Program only for non commercial use.	      * 
; * Ported to PIC12F629 and some functionality added by Felch *
; * felc@edu.ttu.ee											  *
; *************************************************************
Interrupt         
				org     0004h 
Push    		movwf   W_Temp           		; Save W         
				swapf   STATUS,W         
				movwf   S_Temp           		; Save STATUS         
				bcf     pank      				; Select Bank 0 
Disable_Int         	
				bcf     INTCON,GIE       		; Disable all Interrupts         
				btfsc   INTCON,GIE       		; Are Interrupts disabled ?         
				goto    Disable_Int      		; NO, try again          
 ;/*** by Felch ***/
				btfsc   PIR1,TMR1IF      		; Skip Timer 1 Overflow Interrupt ?         
				goto    Timer1_Int        		; NO, goto Timer 1 Interrupt  
				btfsc	INTCON,GPIF				; powerline changed state?
				goto	power_line				; looks like it...
 ;/*** mod end ***/
				btfsc   INTCON,INTF      		; Skip PORTB2/Interrupt?         
				goto    RB2_Int          		; NO, goto RB2          
				btfsc   INTCON,T0IF      		; Skip Timer Overflow Interrupt ?         
				goto    Timer_Int        		; NO, goto Timer Interrupt  
Pop     			
				swapf   S_Temp,W         
				movwf   STATUS           		; Return STATUS         
				swapf   W_Temp,F         
				swapf   W_Temp,W         		; Return W         
				retfie                   		; Return setting GIE  
 ;/*** by Felch ***/
; ***** GPIF power line Interrupt *****  
power_line
				movf	GPIO,W					; read port to reset int condition
				bcf		INTCON,GPIF

				xorwf	Last_GPIO,F				; which pins changed state?
				btfss	Last_GPIO,4				; was it mains input?
				goto	power_mic				; no, then it was mic input
				bsf		CheckTime				; yes, check dimming timer
				movlw	MaxDim
				movwf	Dim_Tick
				movlw	DimTickDefL				; reload dimtimer
				movwf   TMR1L					
				movlw	DimTickDefH
				movwf   TMR1H
				bsf		T1CON,TMR1ON			; start timer 1
				btfsc	Silencio
				goto	power_silence
				movlw	MinTime					; check whistle frequency range
				subwf	WhiCnt1,W ;36
				btfss	CARRY
				goto	power_end
				movlw	MaxTime
				subwf	WhiCnt1,W
				btfsc	CARRY
				goto	power_end
				clrf	WhiCnt1
				decfsz	WhiCnt2,F
				goto	power_end1
				movlw	WhiLen
				movwf	WhiCnt2
				btfsc	Silencio
				goto	power_end1
				bsf		WhiDet
				bsf		Silencio
				movlw	SciTime
				movwf	SciCnt
				goto	power_end1
power_end;		movf	WhiCnt1,W
		;		call	senddata
				clrf	WhiCnt1
				movlw	WhiLen
				movwf	WhiCnt2
power_end1:		movf	GPIO,W					; save port state
				movwf	Last_GPIO
 				goto	Pop
power_mic:		incf	WhiCnt1					; bump sound period counter
				movf	Dim_Tick,W				; check if triac firing point coming soon
				subwf	DIM_Value,W
				sublw	0x02
				btfss	ZERO
				goto	power_mic1				; exit int. saving also GPIO state
power_mic2		bsf		pank					; near to event
				bcf		IOCB,3 ;1					; clear Mic interrupt not to miss dimmer timer's one
				bcf		pank
				goto	power_end1				; and exit enabling Mic later after TMR1 int.
power_silence:	decfsz	SciCnt
				goto	power_end1
				bcf		Silencio				; ready to Rx sound events again
				goto	power_end
power_mic1		movf	DIM_Value,W
				subwf	Dim_Tick,W
				sublw	0x02
				btfss	ZERO
				goto	power_end1				; and exit enabling Mic later after TMR1 int.
				goto	power_mic2
 ;/*** mod end ***/
; ***** RB2/INT RC5 Interrupt *****  
RB2_Int 
				bcf     INTCON,T0IE      		; Disable further Timer0 Interrupts         
				bcf     INTCON,T0IF      		; Clear Overflow Flag          
				movf    TMR0,W           		; Get Timer Value                 
				movwf   T_Temp           		; And rescue          
				movlw   b'00000011'      		; W takes 1:16         
				clrf    TMR0         
				bsf     pank      				; Select Bank 1 
				iorwf   OPTION_REG,F     		; 1:16         
				bcf     pank      				; Select Bank 0 
				bcf     RC5_2nd_Bit  
; ***** First Bit ??? ******          
				movf    RC5_Bit_Count,F         
				btfsc   ZERO         
				goto    RC5_Add_1  
; ***** Decide which window contains T_Temp [ <> 8C <> CF <> ]           
				movlw   h'8C'         
				subwf   T_Temp,W         		; Carry will be cleared if T_Temp < 8C ie 2T         
				btfss   CARRY                   ; Skip if >= 8C         
				goto    Timer_is_2T  	 
; must be >= 8C          
				movlw   h'CF'            		; Idem with CF         
				subwf   T_Temp,W         
				btfss   CARRY         
				goto    Timer_is_3T  
Timer_is_4T         
				btfss   Last_RC5_Bit     		; Was last bit "1" ?         
				goto    RC5_Rx_Error     		; No, was "0", error!         
				goto    RC5_Add_01       		; Last bit was "1", add "01"  
Timer_is_2T         
				btfss   Last_RC5_Bit     		; Was last bit "1" ?         
				goto    RC5_Add_0        		; No, was "0", add "0"         
				goto    RC5_Add_1        		; No, was "1", add "1"  
Timer_is_3T         
				btfss   Last_RC5_Bit     		; Was last bit "1" ?         
				goto    RC5_Add_1        		; No, was "0", add "1"         
				goto    RC5_Add_00       		; Last bit was "1", add "00"  
; ***** If Two Bits must be added, the first one is always a 0  
RC5_Add_01         
				bsf     RC5_2nd_Value         
				goto    RC5_Add_0X  
RC5_Add_00         
				bcf     RC5_2nd_Value  
RC5_Add_0X         
				bsf     RC5_2nd_Bit  
RC5_Add_0         
				bcf     RC5_Bit         
				goto    RC5_Add_Bit  
RC5_Add_1         	
				bsf     RC5_Bit  
RC5_Add_Bit     
				btfss   RC5_Bit          		; Save bit for future         
				goto    RC5_was_0
				bsf     Last_RC5_Bit 
				goto    RC5_Test_End 
RC5_was_0                                       
         		bcf     Last_RC5_Bit                   
RC5_Test_End                                    
				incf    RC5_Bit_Count,F  		; Increment Bit Count
			    movlw   d'2'             		; Test if RC5 bit extended (bit 2)         
				subwf   RC5_Bit_Count,W
			    btfsc   ZERO             		; If extended bit then         
				goto    RC5_Command_Rotate		; add extended bit to Command
; Write your code to test 3-rd bit (new_key_pressed) here if needed /Felch/
			    movlw   d'9'             		; Test Bit Count for >= 9         
				subwf   RC5_Bit_Count,W  		; Carry will be set if >= 9         
				btfss   CARRY            		; Skip if >= 9  ehk kui >=9, on tegemist ksubitiga
				goto	  RC5_check_adr
RC5_Command_Rotate         
				rlf     RC5_Command,1      		; RC5 Command Section         
				bcf     RC5_Command,0         
				btfsc   RC5_Bit          		; Skip next if 0         
				bsf     RC5_Command,0  
RC5_Add_Bit_End         
				btfss   RC5_2nd_Bit      		; Add two bits ?         
				goto    RC5_Int_End      		; No, End Interrupt         
				bcf     RC5_2nd_Bit      		; Two bits, now one bit!         
				btfsc   RC5_2nd_Value    		; Second bit is 0 ?         
				goto    RC5_Add_1        		; No, add a 1         
				goto    RC5_Add_0        		; Yes, add a 0  
RC5_Rx_Error  
RC5_Int_End             
				bsf     INTCON,T0IE      		; Enable Timer0 Interrupts         
				bcf     INTCON,INTF      		; Clear Ext. Interrupt Flag         
				goto    Pop              		; Quit via POP  
RC5_check_adr ; /*** by Felch ***/
				movlw   d'4'		 			; received bit nr. >=4?
				subwf   RC5_Bit_Count,W  		; Carry set if >= 4         
				btfss   CARRY            		; Skip if >= 4  (means we have an address bit)      
				goto	  RC5_Add_Bit_End  		; we have start-bits instead
RC5_Address_Rotate
				rlf     RC5_Address,1      		; RC5 Address Section         
				bcf     RC5_Address,0         
				btfsc   RC5_Bit          		; Skip next if 0         
				bsf     RC5_Address,0  
				goto	RC5_Add_Bit_End  
				
; **** /end of modifications/ ****
Timer_Int                                       ; RC5 Time of the Truth         
				bcf     INTCON,T0IE     		; Disable further Timer0 Interrupts         
				bcf     INTCON,T0IF     		; Clear Overflow       
   
				movlw   d'13'           		; Test Bit Count = 13         
				subwf   RC5_Bit_Count,W 		; Zero will be set if Count = 13         
				btfss   ZERO            		; Skip if = 13, will need to add a 0         
				goto    No_Zero_Needed         
				incf    RC5_Bit_Count,F 		; Increment Bit Count         
				rlf     RC5_Command,1     		; RC5 Command Section         
				bcf     RC5_Command,0  

No_Zero_Needed         
				movlw   b'01000000'     		; Do some cosmetics:         
				xorwf   RC5_Command,F   		; Put extended above normal commands  
; RC5 Gimmicks         
     
				movlw   d'14'           		; Test Bit Count = 14 ;       
				subwf   RC5_Bit_Count,W 		; Zero will be set if Count = 14 ;       
				btfss   ZERO            		; Skip if = 14, do normal ;       
				goto    RC5_was_Err     		; Error  
; /*** by Felch ***/         			
				movlw	d'0'					; how many times same code received ?
				subwf   CmdCounter,W
				btfsc	ZERO					; first time ?
				goto    esimene_kask			; looks like that

				movf	Last_Adr,W				; same adr like in previous packet ?
				subwf   RC5_Address,W   
				btfss   ZERO            
				goto	lopetame				; different! We have trouble, let's get out of here
				movlw   TESTTIMES				; Still same boring command received?
				subwf   CmdCounter,W
				btfsc	ZERO					; really ?
				goto    dekodeeri				; OK, let's see what they want
				goto	 veel_kaske				; not yet...

esimene_kask
				movf    RC5_Address,W   		; Get received address         
				movwf   Last_Adr				; write it down
				movf    RC5_Command,W   		; Get command         
				movwf   Last_Cmd				; memorize it as well
veel_kaske
				incf	CmdCounter,1			; increase command counter
				goto	RC5_Timer_Reset 		; & wait for a new packet


lopetame
				clrf    CmdCounter      		; clean up and...
;				clrf    Last_Cmd         
;				clrf    Last_Adr         
				goto	RC5_Timer_Reset 		; ...wait for better commands from the MASTER


dekodeeri
				clrf    CmdCounter      		; command received successfully, clear registers from accumulated junk  
;				clrf    Last_Cmd         
;				clrf    Last_Adr         
;; Talking to dimmer or switch ?
				btfsc	RC5_Address,4	
				goto	decode_switch_cmds
				goto	decode_dimmer_cmds

; Talking to us ?
decode_switch_cmds
				movf	Device_Address_S,W		; R-switch address
				subwf   RC5_Address,W   
				btfsc   ZERO
				goto    decode_switch_1 		; Did they want us to change addr or what. Not accepted in "circular" transmission.

				movlw   CIRCULAR				; Circular cmd masks
				subwf   RC5_Address,W   
				btfsc   ZERO
				goto    decode_switch_2			; Achtung, all switches!! 
				goto    RC5_Timer_Reset			; not for us, wait for a new packet
 ; 
; they ARE talking to us (as a switch), see what they want (decode command)				
decode_switch_1
				btfsc	New_adr_coming			; are we already expecting a new address ?
				goto	Change_Identity			; yep! Change identity
				movlw   NEW_ADDR				; command to change R-switch address ?
				subwf   RC5_Command,W   
				btfss	ZERO
				goto    decode_switch_2	
				bsf     New_adr_coming			; yep! Warn boss (set flag)
				goto    RC5_Timer_Reset 

decode_switch_2
				movlw   COMON					; command - switch on  ?
				subwf   RC5_Command,W   	
				btfss	ZERO
				goto    decode_switch_3	
;				bsf     pank      				; Select Bank 1 
;				bcf		TRISIO,1				; fire switch triac by setting it's steering pin output
;				bcf     pank      				; Select Bank 0 
				goto    RC5_Timer_Reset 
		
decode_switch_3
				movlw   COMOFF					; command - switch off  ?
				subwf   RC5_Command,W   
				btfss	ZERO
				goto    RC5_Timer_Reset 
;				bsf     pank      				; Select Bank 1 
;				bsf		TRISIO,1				; switch triac off
;				bcf     pank      				; Select Bank 0 
				goto    RC5_Timer_Reset 

; Talking to us (dimmer)?
decode_dimmer_cmds
				movf	Device_Address_D,W		; R-dimmer address
				subwf   RC5_Address,W   
				btfsc   ZERO
				goto    decode_dimmer_1 		; Did they want us to change addr or what. Not accepted in "circular" transmission.

				movlw   CIRCULAR				; Circular cmd masks
				subwf   RC5_Address,W   
				btfsc   ZERO
				goto    decode_dimmer_2			; Beware, all dimmers!!!
				goto    RC5_Timer_Reset			; wait for a new packet
 ; 
; they ARE talking to us (as a dimmer), see what they want (decode command)				
decode_dimmer_1
				btfsc	New_adr_coming			; are we already expecting new address ?
				goto	Change_Identity			; yep! Change identity
				movlw   NEW_ADDR				; command to change R-dimmer address ?
				subwf   RC5_Command,W   
				btfss	ZERO
				goto	decode_dimmer_2
				bsf     New_adr_coming			; yep! Warn the system (set flag)
				goto    RC5_Timer_Reset			; receive it
decode_dimmer_2
				movlw   DIMPLUS					; command - increase brightness  ?
				subwf   RC5_Command,W   	
				btfsc	ZERO
				goto    Inc_Dim					; just do it

				movlw   DIMMINUS				; command - decrease brightness  ?
				subwf   RC5_Command,W   
				btfss	ZERO
				goto	decode_dimmer_3
				movf	DIM_Value,W				; juba pime?
				sublw	MinDim		
				btfss	CARRY
				decf	DIM_Value,F				; vhendame valgustust
				goto	RC5_Timer_Reset 		; next wish to be fullfilled...
decode_dimmer_3
;				movf	RC5_Command,W
				movlw   b'00000011'				; remove brightness value if present
				andwf   RC5_Command,W
				movwf   temp_2					; save
				movlw   DIMVALUE
				subwf   temp_2,W				; was it cmd to set brightness directly ?
				btfss	ZERO
				goto	RC5_Timer_Reset 		; well, that's all, folks ;)
				movlw   b'01111100'				; leave only brightness value
				andwf   RC5_Command,F
				bcf		CARRY
				rrf	  	RC5_Command,W			; shift to correct place
				movwf	RC5_Command
				rrf     RC5_Command,W
				movwf	DIM_Value				; ...and write to system as current value
				goto	RC5_Timer_Reset 		; well, that's all, folks ;)
Inc_Dim
				movlw	MaxDim					; juba max heledus?
				subwf	DIM_Value,W
				btfss	CARRY
				incf	DIM_Value,F				; ei veel, suurenda heledust
				goto    RC5_Timer_Reset
;*******************

RC5_was_Err         
				bcf     New_adr_coming			; error receiving my master's voice. Do NOT change anything !
; **** /end of modifications/ ****

;; Reset RC5 variables  
RC5_Timer_Reset         	
				bsf     Last_RC5_Bit         
				clrf    RC5_Bit_Count         
				clrf    RC5_Command           
				clrf    RC5_Address          
				goto    Pop

; /*** by Felch ***/         			
Change_Identity	
				call	CID
				goto	RC5_Timer_Reset 		; get ready for new command(s)
;*******************
Timer1_Int
				bsf		pank					
				bsf		IOCB,3;1					; re-enable Mic interrupt
				bcf		pank

				bcf		T1CON,TMR1ON			; stop timer 1
				bcf		PIR1,TMR1IF				; clear T1 overflow
				movlw	DimTickDefL				; reload dimtimer
				movwf   TMR1L					
				movlw	DimTickDefH
				movwf   TMR1H
				movf	Dim_Tick,W				; kas aeg mnda smistori torkida?
				subwf	DIM_Value,W
				btfss	ZERO
				goto	t1intend
fire_triac	
				bsf     pank      				; Select Bank 1 
				bcf		TRISIO,5				; fire triac by setting it's steering pin to output
				nop	
				bsf		TRISIO,5				; cease fire ;)
				bcf     pank      				; Select Bank 0 

t1intend		decfsz	Dim_Tick,F				; jrgmine samm
				bsf		T1CON,TMR1ON			; ei veel, taimer uuesti kima
				goto    Pop		
; ************************* 
; ***** Main Program ****** 
; *************************  
Main_Start         
 				call	Init					; set up everything we need
main_loop         
				btfsc	CheckTime				; time to scan buttons (after every zero crossing -> 10mS) ?
				goto	key_02
				btfsc	WhiDet					; oli sobiv vile?
				goto	voice_3					; jepp!
				goto	main_loop

key_02:			bcf		CheckTime
				goto	key_1
key_0
				btfss	Key_down				; was it pressed last time ?
				goto	key_4					; no, exit
				bcf		Key_down				; yes but not any more
				btfss	LastDirection			; toggle LastDirection
				goto	key_01
				bcf		LastDirection
				goto	key_4
key_01	
				bsf		LastDirection
				goto	key_4
key_1
				btfsc   Button      			; Read Button state
				goto	key_0					; not pressed
				bsf		Key_down
				decfsz	Debounce,F				; pressed, but is it long enough ?
				goto	key_4					; not yet				
key_2
				movlw	10h						; reload debounce timer
				movwf	Debounce
				btfss	LastDirection			; last time we... did what?
				goto	key_3
				movlw	MinDim					; ...we incremented, now going to decrease bright; already min. ?
				subwf   DIM_Value,W
				btfss   ZERO
				decf    DIM_Value,F				; make little bit darker...
				goto	key_4					; check mic also
key_3
				movlw	MaxDim					; full bright achieved ?
				subwf   DIM_Value,W
				btfss   ZERO
				incf    DIM_Value,F				; negative, make it brighter
key_4
				goto	main_loop


voice_3:		btfss	LastVoice				; what kind of voice action ?
				goto	voice_1
				movf	DIM_Temp,W				; restore previous brightness
				movwf	DIM_Value
				bcf		LastVoice
				goto	voice_4					; return
voice_1
				movf	DIM_Value,W				; save dim value
				movwf	DIM_Temp
				movlw	MinDim					; shut off light
				movwf	DIM_Value
				bsf		LastVoice
				goto 	voice_4

voice_4:		bcf		WhiDet					; mark sound event processed
				bsf		Silencio				; pause for some time, block receieving sound 
				goto	main_loop
; *********************** 
; * Subroutines         * 
; ***********************  
CID ; Change IDentity ;)
; ***** writes transmitted new device address from RC5_Command to EEPROM'i and system variable Device_addr *****  
				movlw   b'00011111'				; mask everything but received address
				andwf   RC5_Command,W
				bsf     pank      		; Select Bank 1 
				movwf	EEDATA
				movlw	R_Addr_D		 		; EEPROMi location for writing R-dimmers adr.
				btfsc	RC5_Command,4			; are we renaming dimmer's or switches address?
				movlw	R_Addr_S		 		; EEPROMi location for writing R-switch adr.
cid1			movwf	EEADR	
				bcf		INTCON,GIE				; do not let INT's mess things up
				bsf		EECON1,WREN				; enable writing
				movlw	55h						; special writing unlock sequence
				movwf	EECON2
				movlw	0AAh
				movwf	EECON2
				bsf		EECON1,WR					
cid2			
				btfsc	EECON1,WR 				; wait for writing completed
				goto	cid2
				bcf		EECON1,WREN				; disable writing just in case...
				call	Read_Adr				; Read current Device Addresses from EEPROM and write it to system variables "Device_Address_S" and "Device_Address_D" in RAM
				bcf     pank      		; Select Bank 0 
				bcf     New_adr_coming			; command completed, reset corresponding flag
				bsf		INTCON,GIE				; re-enable INT's
				return  
; ***** Read current Device Address from EEPROM and write it to system variables "Device_Address_S" and "Device_Address_D" in RAM *****  
Read_Adr
				bcf     pank      		; Select Bank 0 
				bcf     INTCON,T0IE        		; Timer Interrupts could disturb us so disable them
				movlw	R_Addr_S			 	; EEPROM location to read R-swithes adr.
				bsf     pank      		; Select Bank 1 
				movwf	EEADR	
				bsf		EECON1,RD			 	; start reading
				movf	EEDATA,W
				movwf	Device_Address_S		; write it to system variable

				movlw	R_Addr_D			 	; EEPROM location to read R-dimmers adr.
				movwf	EEADR	
				bsf		EECON1,RD			 	; start reading
				movf	EEDATA,W
				movwf	Device_Address_D		; write it to system variable

				bsf     INTCON,T0IE        		; re-enable timer int's
				bcf     pank      		; Select Bank 0 
				return  
; ***** Initialise system hard- & software *****  
Init          
; **** Read internal ocillator factory calibration  values & apply ****
				bsf     pank      		; Select Bank 1 
				call 	3FFh 					; Get the cal value
				movwf 	OSCCAL 					; Calibrate
				bcf     pank      				; Select Bank 0 
; **** Interrupt system ****
				bcf     INTCON,T0IE        		; No Timer Interrupts         
				clrwdt                    		; Clear WDT (although disabled)       
; ****device options ****
				bsf     pank      				; Select Bank 1 
				movlw   b'00000000'         
				movwf   OPTION_REG      		; Set some options 
; **** I/O-ports data direction setup ****
				bcf     pank      				; Select Bank 0 
				clrf	GPIO					; clear ports
				movlw 	07h 					; Analog comparator off
				movwf 	CMCON 					; must be initialized for digital I/O to work
				bsf     pank      				; Select Bank 1 
				movlw	0x3D;3Fh						; all are inputs 
				movwf 	TRISIO 
				movlw	05h						; now WPU-s (1F)(15 kui zeroX transsi ei ole)
				movwf	WPU
				movlw	18h;12h						; enable int on change for power line and Mic 
				movwf	IOCB
				bcf     pank      				; Select Bank 0 
				movlw	0x2F;27h						; set initial state for port pins (2F)
				movwf 	GPIO 
; **** see if user wanted to reset device addresses to default setings ****
				movlw   d'50'     
				movwf   Debounce 
But_check		btfsc   Button      			; Read Button state for some time
				goto	initRC5					; pressed too short time or not at all, forget resetting
				decfsz  Debounce,1         
				goto    But_check 

				movlw   Dev_Adr_Def_S			; R-switch 
				bsf     pank      		; Select Bank 1 
				movwf	EEDATA
				movlw	R_Addr_S		 		; EEPROMi location for writing R-switch adr.       
				call	cid1					; change it!
				movlw   Dev_Adr_Def_D			; R-dimmer 
				bsf     pank      		; Select Bank 1 
				movwf	EEDATA
				movlw	R_Addr_D		 		; EEPROMi location for writing R-dimmer adr.       
				call	cid1					; change it!

				bsf     pank      		; flash dimmer and switch outputs to indicate accepting reset
				movlw	0x3D;3fh					
				movwf 	TRISIO 
				movlw   d'255'     
				movwf   Debounce 
B_chk_1			decfsz  Debounce,1         
				goto    B_chk_1 
B_chk_2			btfsc	Button					; wait for Button released (lights on meanwhile!)
				goto	B_chk_3
        		goto	B_chk_2
B_chk_3		
				movlw	0x3d;3Fh						; off!
				movwf 	TRISIO 
				bcf     pank      				; Select Bank 0 
; **** Init RC5 variables ****
initRC5			bsf     Last_RC5_Bit         
				clrf    RC5_Bit_Count         
				clrf    RC5_Command  
				clrf    CmdCounter         
				clrf    Last_Cmd         
				clrf    Last_Adr         
				call	Read_Adr				; Read current Device Address from EEPROM and write it to system variables "Device_Address_S" and "Device_Address_D" in RAM
; **** int's and power line variables ****
				bsf		INTCON,PEIE				; enable peripheral ints
				bcf		INTCON,T0IE				; clear int. flags
				bcf		INTCON,GPIF				; port change flag
				bsf		INTCON,GPIE				; enable port on change int (will use it for power line status sensing) ****************
				bsf     INTCON,INTE       		; Enable GP2/INT  
;				bcf		OPTION_REG,INTEDG		; Int on rising edge of signal**********
				movlw	MinDim					; switch off lamps on start-up
				movwf	DIM_Value	      		
				movlw	MaxDim
				movwf	Dim_Tick
				movlw	MaxDim					; but after clapping hands switch them fully on
				movwf	DIM_Temp
; **** Timer 1 ****
				movlw	b'00000100'				; 1/1 prescaler, int osc, seisma
				movwf	T1CON
				bcf		PIR1,TMR1IF				; clear possible overflow
				bsf     pank      				; Select Bank 1 
				bsf		PIE1,TMR1IE				; enable T1 int
				bcf     pank      				; Select Bank 0 
				bcf		T1CON,TMR1ON			; stop timer 1 (to make sure its not ticking somewhere & somehow...)
				movlw	DimTickDefL				; reload dimtimer
				movwf   TMR1L					
				movlw	DimTickDefH
				movwf   TMR1H
; **** Inc/dec etc..flags ****
;				bcf		Vox
				bcf		WhiDet
				clrf	Last_GPIO
				bcf		LastVoice
				movlw	WhiLen
				movwf	WhiCnt2
				bcf		LastDirection			; next button press increments brightness
				movlw	5h						; reload debounce timer
				movwf	Debounce
;				movwf	Debounce1
				bcf		CheckTime				; no time to check button or mic
				bsf     INTCON,GIE        		; Enable Interrupts Global 
    			return  
; ***** Reset 12F629 *****          
				org     03FEh         
				goto    Reset					; shouldn't get here but if does,...we've born again...         

				org		03FFh
				retlw	b'0011111'				; this is NOT a real value, let Your programmer use the value read from Your chip!!!!
	END  
